library Parser;

uses
  Windows, Messages;

var Chrs: Array[0..255] of String;
    f: Integer;
    Buf: Array[0..9] of Char;

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

function sTextToVK(Str: String): Integer;
begin
Str:=LowerCase(Str);
for f:=0 to 255 do begin
        if Str=Chrs[f] then Break;
end;
if f=256 then f:=-1;
Result:=f;
end;

function CutStr(Str: String; WordNum: Integer): String;
var Pss: Integer;
    NMW: Integer;
begin
pss:=0;
Result:='';
NMW:=0;
While WordNum>0 do begin
        Inc(Pss);
        NMW:=Pss;
        while (Pss<Length(str)) and (Str[Pss]<>';') do Inc(Pss);
        Dec(WordNum);
        if (Pss=Length(str)) and (WordNum>0) then Exit;
        if Pss=Length(str) then break;
end;
Result:=Copy(Str, NMW, Pss-NMW);
end;

function ParseScript(Str: PChar): Boolean; stdcall;
var outs: String;
    cn: Integer;
    Key: Integer;
    KeyS: String;
begin
cn:=2;
outs:=LowerCase(CutStr(Str, cn));
Result:=True;
while outs<>'' do begin
        if outs='/mn' then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_MINIMIZE, 0);
        if outs='/mx' then if IsZoomed(GetForegroundWindow) then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_RESTORE, 0) else SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
        if outs='/cl' then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_CLOSE, 0);
        if outs='/tm' then SetWindowPos(GetForegroundWindow, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
        if outs='/ntm' then SetWindowPos(GetForegroundWindow, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
        if outs[1]='+' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                if KeyS='lwin' then Key:=$5B else if KeyS='rwin' then Key:=$5C else Key:=sTextToVK(KeyS);
                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
        end;
        if outs[1]='-' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                if KeyS='lwin' then Key:=$5B else if KeyS='rwin' then Key:=$5C else Key:=sTextToVK(KeyS);
                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP	, 0);
        end;
        if outs[1]='*' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                if KeyS='lwin' then Key:=$5B else if KeyS='rwin' then Key:=$5C else Key:=sTextToVK(KeyS);
                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP	, 0);
        end;
        Inc(cn);
        outs:=LowerCase(CutStr(Str, cn));
end;
end;

exports ParseScript;

begin
// Init key table
for f:=0 to 255 do begin
        GetKeyNameText(MapVirtualKey(f,0) shl 16, @Buf, 10);
        Chrs[f]:=LowerCase(Buf);
end;
end.
